'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _raxPicture = require('rax-picture');

var _raxPicture2 = _interopRequireDefault(_raxPicture);

var _raxView = require('rax-view');

var _raxView2 = _interopRequireDefault(_raxView);

var _raxText = require('rax-text');

var _raxText2 = _interopRequireDefault(_raxText);

var _raxLink = require('rax-link');

var _raxLink2 = _interopRequireDefault(_raxLink);

var _style = require('./style');

var _style2 = _interopRequireDefault(_style);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Card = function (_Component) {
  _inherits(Card, _Component);

  function Card() {
    _classCallCheck(this, Card);

    return _possibleConstructorReturn(this, (Card.__proto__ || Object.getPrototypeOf(Card)).apply(this, arguments));
  }

  _createClass(Card, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return !nextProps.dataSource || nextProps.dataSource[0].itemId !== this.props.dataSource[0].itemId;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          dataSource = _props.dataSource,
          otherProps = _objectWithoutProperties(_props, ['dataSource']);

      if (dataSource.length === 0) {
        return null;
      }
      var returnDOM = dataSource.map(function (item, index) {
        var titleLineClamp = item.titleLineClamp ? item.titleLineClamp : 1;
        var subTitleLineClamp = item.subTitleLineClamp ? item.subTitleLineClamp : 1;
        var descLineClamp = item.descLineClamp ? item.descLineClamp : 1;

        return (0, _rax.createElement)(
          _raxLink2.default,
          _extends({ key: index, href: item.url, style: _style2.default.itemwrap }, otherProps),
          (0, _rax.createElement)(
            _raxView2.default,
            { style: _style2.default.item },
            (0, _rax.createElement)(_raxPicture2.default, { source: { uri: item.pic }, style: _style2.default.pic }),
            (0, _rax.createElement)(
              _raxView2.default,
              { style: _style2.default.content },
              (0, _rax.createElement)(
                _raxView2.default,
                { style: _style2.default.textwrap },
                (0, _rax.createElement)(
                  _raxText2.default,
                  { numberOfLines: titleLineClamp, style: _style2.default.title },
                  item.title
                ),
                item.subTitle ? (0, _rax.createElement)(
                  _raxText2.default,
                  { numberOfLines: subTitleLineClamp, style: _style2.default.subtitle },
                  item.subTitle
                ) : null,
                item.desc ? (0, _rax.createElement)(
                  _raxText2.default,
                  { numberOfLines: descLineClamp, style: _style2.default.desc },
                  item.desc
                ) : null
              ),
              (0, _rax.createElement)(
                _raxView2.default,
                { style: _style2.default.sign },
                item.price ? (0, _rax.createElement)(
                  _raxText2.default,
                  { style: _style2.default.highlightext },
                  item.price
                ) : null,
                item.discount ? (0, _rax.createElement)(
                  _raxText2.default,
                  { style: _style2.default.weakentext },
                  item.discount
                ) : null
              ),
              item.extra ? (0, _rax.createElement)(
                _raxText2.default,
                { style: _style2.default.extratext },
                item.extra
              ) : null,
              item.tagging ? (0, _rax.createElement)(
                _raxText2.default,
                { style: _style2.default.tagtext },
                item.tagging
              ) : null
            )
          )
        );
      });

      return (0, _rax.createElement)(
        _raxView2.default,
        { style: _style2.default.container },
        returnDOM
      );
    }
  }]);

  return Card;
}(_rax.Component);

exports.default = Card;
module.exports = exports['default'];